CT_RABossSarf_Firelord_Setup = {
	lavaSpawnCount = 0;
	lavaSpawnTime = 0;
};

CT_RABossSarf_Firelord_LavaSpawnSounds = {
	["eeeh Lava Spawn.mp3"] = 10;
	["eehh Lava Spawn.mp3"] = 15;
	["ehh Lava Spawn.mp3"] = 10;
	["llava Spawn.mp3"] = 5;
	--"Lava Spawns.mp3"
	--"lots of Lava Spawn.mp3"
};

function CT_RABossSarf_Firelord_GetLavaSpawnSound()
	local n = 0;
	if not CT_RABossSarf_Firelord_LavaSpawnSounds.n then
		for k,v in CT_RABossSarf_Firelord_LavaSpawnSounds do
			n = n + v;
		end
		CT_RABossSarf_Firelord_LavaSpawnSounds.n = n;
	else
		n = CT_RABossSarf_Firelord_LavaSpawnSounds.n;
	end
	local r = random(1, CT_RABossSarf_Firelord_LavaSpawnSounds.n);
	for k,v in CT_RABossSarf_Firelord_LavaSpawnSounds do
		n = n - v;
		if n <= 0 then
			return k;
		end
	end
	return nil;
end

tinsert(CT_RABoss_ModsToLoad, "CT_RABossSarf_Firelord_OnLoad");

function CT_RABossSarf_Firelord_OnLoad()
	CT_RABoss_AddMod(CT_RABOSS_FIRELORD_NAME, CT_RABOSS_FIRELORD_INFO, 1, CT_RABOSS_LOCATIONS_MOLTENCORE);
	
	CT_RABoss_AddEvent(CT_RABOSS_FIRELORD_NAME, "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABossSarf_Firelord_EventHandler);
	
	CT_RABoss_AddDropDownButton(CT_RABOSS_FIRELORD_NAME, { CT_RABOSS_FIRELORD_ALERT_LAVASPAWN, CT_RABOSS_FIRELORD_ALERT_LAVASPAWN_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "alertLavaSpawn", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton(CT_RABOSS_FIRELORD_NAME, { CT_RABOSS_FIRELORD_TARGET_LAVASPAWN, CT_RABOSS_FIRELORD_TARGET_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "targetLavaSpawn", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton(CT_RABOSS_FIRELORD_NAME, { CT_RABOSS_FIRELORD_ANNOUNCE_LAVASPAWN, CT_RABOSS_FIRELORD_ANNOUNCE_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "announceRaidLavaSpawn", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton(CT_RABOSS_FIRELORD_NAME, { CT_RABOSS_FIRELORD_SOUND_LAVASPAWN, CT_RABOSS_FIRELORD_SOUND_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "announceRaidLavaSpawnSound", "CT_RABoss_SetInfo");
	CT_RABoss_SetVar(CT_RABOSS_FIRELORD_NAME, "announceRaidLavaSpawnSound", true);
end


function CT_RABossSarf_Firelord_LavaSpawn_Target()
	local targetName = UnitName("target");
	if ( UnitExists("target") ) and ( not UnitIsDead("target") ) then
		if ( targetName == CT_RABOSS_FIRELORD_NAME_LAVASPAWN ) and ( not UnitIsCorpse("target") ) then
			return;
		end
		local isMainTank = false;
		for k, v in CT_RATarget.MainTanks do
			if ( UnitIsUnit("raid" .. ( v[1] or "" ), "player") ) then
				isMainTank = true;
				break;
			end
		end
		--if ( isMainTank ) and ( targetName == CT_RABOSS_FIRELORD_NAME ) then
		if ( isMainTank ) and ( UnitIsUnit("player", "targettarget") ) then
			return;
		end
	end
	TargetByName(CT_RABOSS_FIRELORD_NAME_LAVASPAWN, 1);
end

function CT_RABossSarf_Firelord_EventHandler(event)
	local firelordOptions = CT_RABoss_Mods[CT_RABOSS_FIRELORD_NAME];
	if ( not firelordOptions or not firelordOptions["status"] or not firelordOptions.enabled ) then
		return;
	end
	if ( arg1 == CT_RABOSS_FIRELORD_SPELL_LAVASPAWN ) then
		local setup = CT_RABossSarf_Firelord_Setup;
		setup.lavaSpawnCount = setup.lavaSpawnCount + 1;
		setup.lavaSpawnTime = GetTime();
		if ( firelordOptions["announceRaidLavaSpawn"] ) or ( firelordOptions["alertLavaSpawn"] ) then
			CT_RABoss_Announce(CT_RABOSS_FIRELORD_MSG_SPAWN, firelordOptions["announceRaidLavaSpawn"]);
			if ( not firelordOptions["alertLavaSpawnSound"] ) then
				CT_RABoss_PlaySound(3);
			end
		end
		if ( firelordOptions["alertLavaSpawnSound"] ) then
			local sound = CT_RABossSarf_Firelord_GetLavaSpawnSound();
			if ( sound ) then
				PlaySoundFile("Interface\\AddOns\\CT_RABossModsSarf\\Sounds\\"..sound);
			end
		end
		if ( firelordOptions["targetLavaSpawn"] ) then
			CT_RABoss_Schedule("CT_RABossSarf_Firelord_LavaSpawn_Target", 1);
		end
	end
end
